#!/bin/bash
#
#	TongWEB 5.0 
#
#OCF_RESKEY_osuser=root
#OCF_RESKEY_osuser=tongweb
#OCF_RESKEY_install_path=/opt/TongWeb
OCF_RESKEY_adminiserverip=${2}
OCF_RESKEY_port=${3}
#OCF_RESKEY_sleeptime=35
#######################################################################
# Initialization:
#. ${OCF_ROOT}/resource.d/heartbeat/.ocf-shellfuncs 
#. /opt/NeoShineHA/lib/ocf/resource.d/heartbeat/.ocf-shellfuncs 
# Initialization:
#OCF_ROOT=/usr/lib/ocf
#: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
#. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
#######################################################################
#USER=$OCF_RESKEY_osuser
#TWPATH=$OCF_RESKEY_install_path

STATE_OK=0
STATE_WARNING=1
STATE_CRITICAL=2
STATE_UNKNOWN=3
STATE_ERR_ARGS=4

CMD=`basename $0`

abort_timeout=10
meta_data() {
	cat <<END
<?xml version="1.0"?>
<!DOCTYPE resource-agent SYSTEM "ra-api-1.dtd">
<resource-agent name="tongweb">
<version>1.0</version>
<longdesc lang="en">
This is a TongWEB Resource Agent.
</longdesc>
<shortdesc lang="en">TongWEB  resource agent</shortdesc>
<parameters>
<parameter name="osuser" unique="1" required="1">
<longdesc lang="en">
The name of tw operation system user name. 
</longdesc>
<shortdesc lang="en">OS user name</shortdesc>
<content type="string" default="root" />
</parameter>
<parameter name="install_path" unique="2" required="1">
<longdesc lang="en">
The install abosolut path  of tongweb like /home/TongWeb4.6. 
</longdesc>
<shortdesc lang="en">TW install abs path</shortdesc>
<content type="string" default="" />
</parameter>
<parameter name="sleeptime" unique="1" required="1">
<longdesc lang="en">
The time star process need to sleep,maybe need change
</longdesc>
<shortdesc lang="en">The time star process need to sleep,maybe need change</shortdesc>
<content type="string" default="35" />
</parameter>
</parameters>
<actions>
<action name="monitor"      timeout="10s" interval="5s" depth="0" start-delay="30s" />
<action name="meta-data"    timeout="5s" />
</actions>
</resource-agent>
END
}

#######################################################################

tw_usage() {
	cat <<END
usage: $CMD monitor adminiserverip port 
END
}

tw_monitor() {
    if [ `ps awx|grep  java|grep -c "com.tongweb.server.PELaunch start" | grep -v grep ` -gt 0 ]; then
       /usr/bin/wget -O- -q -L http://$OCF_RESKEY_adminiserverip:$OCF_RESKEY_port/twns | tr '\012' ' ' | grep -Ei "html" >/dev/null 2>&1
        if [ $? -eq 0 ];then
            #key-key
            echo "OK TongWEB server is running|state=0"
            #echo "service_TongWEB_ok"
            exit $STATE_OK
        else
            #key-key
            echo "CRITICAL TongWEB server is error|state=1"
            #echo "service_TongWEB_critical_error "
            exit $STATE_CRITICAL
        fi
    else
        #key-key
        echo "CRITICAL TongWEB server is not running|state=1"
        #echo "service_TongWEB_critical_not_running "
        exit $STATE_CRITICAL
    fi
}

#
#       'main' starts here...
#

if
  ( [ $# -ne 3 ] )
then
  tw_usage
  exit $STATE_ERR_ARGS
fi

case "$1" in
meta-data)	meta_data
		exit $OCF_SUCCESS
		;;
monitor)	tw_monitor ;;
usage|help)	tw_usage
		exit $OCF_SUCCESS
		;;
*)		tw_usage
		exit $OCF_ERR_UNIMPLEMENTED
		;;
esac
exit $?
