#!/bin/bash
#
#	do the real work of krmsd

# Source function library.
[ -e /etc/init.d/functions ] && . /etc/init.d/functions

print_usage()
{
    echo "Usage: check_kingbase7.sh --status <Kingbase installation directory>"
    return 0
}

[ -z "${1:-}" -o -z "${2:-}" ] && print_usage && exit 1

bin_dir=$2/bin
prog_user=""
platform=`uname -s`
prog="krms"

# function __pids_pidof and __pids_var_run are imitated from /etc/init.d/functions
__pids_pidof() 
{
    pidof -o $$ -o $PPID -o %PPID -x "$1"
}
	
__pids_var_run() 
{
    local base=$1
    #local pid_file=${2:-/var/run/$base.pid}
    local pid_file=${2:-/tmp/.es.kingbase.$base.pid}
	
    pid=
    if [ -f "$pid_file" ] ; then
        local line p
	read line < "$pid_file"

	for p in $line ; do
      	    [ -z "${p//[0-9]/}" -a -d "/proc/$p" ] && pid="$pid $p"
	done

	if [ -n "$pid" ]; then
	    return 0
	fi

	return 1 # "Program is dead and /var/run pid file exists"
    fi
    return 3 # "Program is not running"
}

# krms must have execute permission
#if [ ! -x "$bin_dir"/$prog ]; then
#    echo "Kingbase Installation directory is invalid"
#    exit 1
#fi

case "$1" in
    --status)
    	# Next try "/var/run/*.pid" files
    	__pids_var_run "$prog"
    	# change $? to $state for bug 24774 by cailiuqing 0913
    	state=$?
    	case "$state" in
    	    0)
		#key-key
    		echo $"${prog} (pid $pid) is running...|state=0"
    		#echo "service_kingbase_ok#$pid"
	    	;;
    	    1)
		#key-key
	   	echo $"${prog} dead but pid file exists.|state=1"
	   	#echo "service_kingbase_dead_but_pid_file_exists"
       	    	;;
       	    *)
		#key-key
    		echo $"${prog} is stopped.|state=1"
    		#echo "service_kingbase_stopped"
    		#add for bug 24774
    		exit 2
               	;;
    	esac
        ;;
    *)
	print_usage	
        ;;
esac

exit $state

