#!/bin/sh
#
# 
# oscar database
#
# Description:	Manages oscar database as Linux-HA resource

#
# Author:	CS2C		
# Support:	support@cs2c.com.cn
# License:	GNU General Public License (GPL)
# Copyright:	(C) 2009 CS2C
# For oscar version: 7.0
#
# See usage() function below for more details...
#
# OCF instance parameters:
#   OCF_RESKEY_OSCAR_HOME=/home/oscar

#######################################################################
# Initialization:

#. ${OCF_ROOT}/resource.d/heartbeat/.ocf-shellfuncs
#. /opt/NeoShineHA/lib/ocf/resource.d/heartbeat/.ocf-shellfuncs

# Initialization:
#OCF_ROOT=/usr/lib/ocf
#: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
#. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
#######################################################################
#isql_command=`find $OCF_RESKEY_OSCAR_HOME -name "isql"`

STATE_OK=0
STATE_WARNING=1
STATE_CRITICAL=2
STATE_UNKNOWN=3
STATE_ERR_ARGS=4

CMD=`basename $0`

usage() {
  cat <<UEND
	usage: $0 (start|stop|validate-all|meta-data|monitor)

	$0 manages a DM Database as an HA resource.

	The 'start' operation starts the database.
	The 'stop' operation stops the database.
	The 'status' operation reports whether the database is running
	The 'monitor' operation reports whether the database seems to be working
	The 'validate-all' operation reports whether the parameters are valid

UEND
}

oscar_status() {
	pid_num_oscar=`ps cax -o pid,command | egrep -w "oscar" | grep -c oscar`
	pid_num_oscaragent=`ps cax -o pid,command |egrep -w "oscaragent" | grep -c oscaragent`
	
        if [ $pid_num_oscar -ge 1 -a $pid_num_oscaragent -ge 1 ]; then
             #ocf_log debug "oscar server is running"
	     echo "OK:oscar server is running|state=0"
             exit $STATE_OK
        else 
             #ocf_log debug "oscar server is not runnning"
	     echo "CRITICAL:oscar server is not runnning|state=1"
             exit $STATE_CRITICAL
        fi
}


# What kind of method was invoked?
case "$1" in
  monitor)	oscar_status;;

 *)		usage
		exit 0;;
esac
exit $?
