#!/bin/bash
## Program for check average number of process with mult-core-cpu
##  add by liuqing.cai 2012-02-17

LINE=`/opt/cobra/icinga/libexec/check_procs $*`
# make sure command has arguments
# add by liuqing.cai 2012-03-13 begin
ARG_NUM=$#
if [ "$ARG_NUM" -eq 0 ]
then
	/opt/cobra/icinga/libexec/check_procs -h
	exit
fi
# end

COUNT=`echo $LINE | awk '{gsub(/[^0-9]+/,"",$3);print $3}'`

# Getting parameters:
while getopts "w:c:h" OPT; do
        case $OPT in
                "w") warning=$OPTARG;;
                "c") critical=$OPTARG;;
#                "h") help;;
        esac
done

# begin
if [ "$warning" -ge "$critical" ]
then
	echo Warning must be less than critica.Please change arguments.
	exit
fi

# end

# add flag of "Total"
LINE=$LINE"(Total)"

# get the number of cpu
CPU_COUNT=`cat /proc/cpuinfo | grep "core id" | wc -l`

# get the average number of count
COUNT=$(($COUNT/$CPU_COUNT))

# Printing the results:
if (("$COUNT" < "$warning"));then
	#key-key
	echo PROCS OK: The average count is $COUNT \| procs=$COUNT 
	#echo service_procs_ok#$COUNT \| procs=$COUNT
	exit 0
elif (("$warning" < "$COUNT")) && (("$COUNT" < "$critical"));then
	#key-key
	echo PROCS WARNING: The average count is $COUNT \| procs=$COUNT
	#echo service_procs_warning#$COUNT \| procs=$COUNT
	exit 1
elif (("$COUNT" > "$critical"));then
	#key-key
	echo PROCS CRITICAL: The average count is $COUNT \| procs=$COUNT
	#echo service_procs_critical#$COUNT \| procs=$COUNT
	exit 2
else
	#key-key
	echo UNKNOWN
	#echo "service_procs_unknown"
	exit 3
fi	 
